@import '../../styles/variables';
@import '../../styles/mixins';

.cui-button {
  position: relative;
  display: inline-flex;
  flex-shrink: 0;
  align-items: center;
  justify-content: center;
  border: none;
  border-radius: cui-border-radius(m);
  outline: 0;
  font-size: cui-font-size(m);
  text-decoration: none;
  transition:
    background-color $cui-hover-transition,
    color $cui-hover-transition,
    box-shadow $cui-focus-transition;
  @include cui-no-select();

  &.cui-round,
  &.cui-icon-button {
    border-radius: 10rem;
  }

  &:focus { outline: none !important; }
  &.cdk-program-focused,
  &.cdk-keyboard-focused {
    box-shadow: 0 0 0 2px $cui-focus-color;

    &.cui-focus-in {
      box-shadow: inset 0 0 0 2px $cui-focus-color;
    }
  }

  &:not([disabled]) {
    cursor: pointer;
  }
  &[disabled] {
    cursor: not-allowed;
    opacity: $cui-disabled-opacity;
  }

  &.cui-loading {
    .cui-spinner {
      position: absolute;
    }

    > *:not(.cui-spinner) {
      visibility: hidden;
    }
  }

  .cui-button-content {
    @include cui-ellipsis;
  }

  // ----- modes

  @mixin mode($mode) {
    &:where([data-cui-mode='#{$mode}']) {
      background-color: cui-color($mode, bg);
      color: cui-color($mode, fill);

      &:not([disabled]):not([data-cui-look='link']):focus {
        color: cui-color($mode, fill);
      }
      &:not([disabled]):hover {
        background-color: cui-color($mode, bg-hover);
        color: cui-color($mode, fill-hover);
      }
      &:not([disabled]):active {
        background-color: cui-color($mode, bg-active);
        color: cui-color($mode, fill-active);
      }
    }

    &:where([data-cui-mode='#{$mode}'][data-cui-look='link']) {
      background-color: transparent;
      color: cui-color($mode, text);

      &:not([disabled]):focus {
        color: cui-color($mode, text);
      }
      &:not([disabled]):hover {
        background-color: transparent;
        color: cui-color($mode, text-hover);
        text-decoration: underline;
      }
      &:not([disabled]):active {
        background-color: transparent;
        color: cui-color($mode, text-active);
        text-decoration: underline;
      }
    }
  }

  @include mode('primary');
  @include mode('secondary');
  @include mode('ghost');
  @include mode('success');
  @include mode('error');
  @include mode('custom');

  // ----- sizes

  @mixin size($size, $padding, $fontSize: null, $iconSize: 1.25rem) {
    &:where([data-cui-size='#{$size}']) {
      height: cui-height($size);
      min-width: cui-height($size);
      padding: 0 $padding;
      font-size: $fontSize;

      &.cui-icon-button {
        width: cui-height($size);
        min-width: initial;
        padding: 0;
      }

      .cui-icon,
      .cui-spinner {
        font-size: $iconSize;
      }

      .cui-spinner {
        top: calc(50% - #{$iconSize * 0.5});
        left: calc(50% - #{$iconSize * 0.5});
      }

      .cui-icon-prefix { margin-right: $padding * 0.5; }
      .cui-icon-suffix { margin-left: $padding * 0.5; }

      // ----- neg. margins
      $-margin-h: -$padding;
      $-margin-v: (cui-line-height($size) - cui-height($size)) * 0.5;

      &.cui-button-pull-t { margin-top: $-margin-v !important; }
      &.cui-button-pull-l { margin-left: $-margin-h !important; }
      &.cui-button-pull-b { margin-bottom: $-margin-v !important; }
      &.cui-button-pull-r { margin-right: $-margin-h !important; }
      &.cui-button-pull-h { margin-left: $-margin-h !important; margin-right: $-margin-h !important; }
      &.cui-button-pull-v { margin-top: $-margin-v !important; margin-bottom: $-margin-v !important; }
      &.cui-button-pull { margin: $-margin-v $-margin-h !important; }

      // --- deprecated
      &.cui-button-pull-out-t { margin-top: $-margin-v; }
      &.cui-button-pull-out-l { margin-left: $-margin-h; }
      &.cui-button-pull-out-b { margin-bottom: $-margin-v; }
      &.cui-button-pull-out-r { margin-right: $-margin-h; }
      &.cui-button-pull-out-h { margin-left: $-margin-h; margin-right: $-margin-h; }
      &.cui-button-pull-out-v { margin-top: $-margin-v; margin-bottom: $-margin-v; }
      &.cui-button-pull-out { margin: $-margin-v $-margin-h; }
    }
  }

  @include size('xs', .25rem, cui-font-size(s), 1rem);
  @include size('s', .5rem);
  @include size('m', 1rem);
  @include size('l', 1.5rem);
  @include size('xl', 1.75rem, cui-font-size(l), 1.5rem);
}
